package com.zipcodewilmington.arrayutility;

import java.util.*;
import java.util.stream.Collector;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {
private T[] inputArray;
private List<T> arrays = new ArrayList<>();
    private List<T> anotherArray = new ArrayList<>();


    public ArrayUtility(T[] inputArray) {
        this.inputArray = inputArray;
    }

    public T[] removeValue(T valueToRemove) {
        arrays.addAll(Arrays.asList(inputArray));
        arrays.removeIf(t -> t.equals(valueToRemove));
        return arrays.toArray(Arrays.copyOf(inputArray,arrays.size()));
    }



    public T getMostCommonFromMerge(T[] arrayToMerge) {
        arrays.addAll(Arrays.asList(inputArray));
        arrays.addAll(Arrays.asList(arrayToMerge));

        Object[] temp = arrays.toArray();

        Object element = null;
        int count = 0;
        for (int i = 0; i < temp.length; i++) {
            Object tempElement = temp[i];
            int tempCount = 0;
            for(int p = 0; p < temp.length; p++){
                if(temp[p].equals(tempElement)){
                    tempCount++;
                }
            }
            if(tempCount>count){
                element = tempElement;
                count = tempCount;
            }

        }
        return (T)element;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        arrays.addAll(Arrays.asList(inputArray));
        int count = 0;

        for(T t : arrays){
            if(t.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }


    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        arrays.addAll(Arrays.asList(inputArray));
        arrays.addAll(Arrays.asList(arrayToMerge));

        int count = 0;
        for(T t : arrays){
            if (t.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }


    public T[] getInputArray() {
        return inputArray;
    }
}
